<?php

namespace Modules\Cotacao\Modules\AnaliseCotacoes\Services;

use Doctrine\ORM\EntityManager;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Sup03400ConsultaDeMelhoresPrecosService
{

    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager, $connection)
    {
        $this->entityManager = $entityManager;
        $this->connection   = $connection;
    }


    public function getCdFilial($cdfilial)
    {
        $query = $this->entityManager->getConnection()->prepare(
            "SELECT DISTINCT
                NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)  AS CDFILIAL
              FROM
                FILIAL FIL,
                FILIAL
              WHERE
                (FILIAL.CDFILIAL = :P_CDFILIAL) AND
                NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = FIL.CDFILIAL"
        );
        $query->execute(
            array(
                "P_CDFILIAL" => $cdfilial
            )
        );
        $cdfilial2 = $query->fetchAll()[0]["CDFILIAL"];
        return $cdfilial2;
    }

    public function ideal4Forn($P_CDFILCENTCMP, $P_CDREGIAO, $P_CDFORNECED, $P_CDCOMPRADOR, $P_DTINI, $P_DTFIN, $P_PRODINI, $P_PRODFIN, $P_NRORG)
    {
        $connection = $this->connection;
        $procedure = new StoredProcedure($connection, 'IDEAL_4FORN_REPORT');
        $procedure->addParam(new Param('P_CDFILCENTCMP', Param::PARAM_INPUT, $P_CDFILCENTCMP, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDREGIAO',    Param::PARAM_INPUT, $P_CDREGIAO, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFORNECED',    Param::PARAM_INPUT, $P_CDFORNECED, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCOMPRADOR',    Param::PARAM_INPUT, $P_CDCOMPRADOR, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINI',    Param::PARAM_INPUT, $P_DTINI, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFIN',    Param::PARAM_INPUT, $P_DTFIN, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PRODINI',    Param::PARAM_INPUT, $P_PRODINI, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PRODFIN',    Param::PARAM_INPUT, $P_PRODFIN, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQEMISSAO',  Param::PARAM_OUTPUT, null,         Param::PARAM_TYPE_STR, 20));
        $procedure->addParam(new Param('P_NRORG',    Param::PARAM_INPUT, $P_NRORG, Param::PARAM_TYPE_STR));
        $nrseqemissao = $procedure->execute();
        return $nrseqemissao["P_NRSEQEMISSAO"];
    }

    /*
    public function removeIdeal4Forn($nrseqemissao) {
        $query = "DELETE FROM IDEAL_4FORN WHERE NRSEQEMISSAO = :P_NRSEQEMISSAO";
        $params = array(
            "P_NRSEQEMISSAO" => $nrseqemissao
        );
        $sql = $this->connection->prepare($query);
        $sql->execute($params);
    }
    */
}
