<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;

class MigEnderecoparc extends Base\MigEnderecoparc
{

    const EXPRESSAO_NUMEROS = '/[^0-9]/';
    const TP_ENDERECO_PRINCIPAL = "PRINCIPAL";

    /**
     * @param $nrenderecoparc
     * @return MigEnderecoparc
     */
//    public function setNrenderecoparc ($nrenderecoparc) {
//        $nrenderecoparc = \Importacao\Logic\Validacoes::verificaChaveDuplicada('ENDERECOPARC', 'NRENDERECOPARC', \FPA::getNrorgTrabalho(), $nrenderecoparc);
//        $this->nrenderecoparc = $nrenderecoparc;
//    }

    /**
     * @param $nrparcnegocio
     * @throws \Exception
     * @return MigEnderecoparc
     */
    public function setNrparcnegocio ($nrparcnegocio) {
        if (empty($nrparcnegocio)) {
            throw new \Exception("Campo Obrigatório: 'Nr. Parceiro Negócio'");
        }

        $this->nrparcnegocio = $nrparcnegocio;
    }

    /**
     * @param $cdtipoendereco
     * @throws \Exception
     * @return MigEnderecoparc
     */
    public function setCdtipoendereco ($cdtipoendereco) {
        if (empty($cdtipoendereco)) {
            $cdtipoendereco = self::TP_ENDERECO_PRINCIPAL;
        }

        $this->cdtipoendereco = self::TP_ENDERECO_PRINCIPAL;
    }

    /**
     * @param mixed $dtinclusao
     * @throws \Exception
     * @return MigEnderecoparc|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data com formato inválido.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @return MigEnderecoparc|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data com formato inválido.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param $nrcependereco
     * @return MigEnderecoparc
     */
    public function setNrcependereco ($nrcependereco) {
        $nrcependereco = preg_replace(self::EXPRESSAO_NUMEROS, "", $nrcependereco);
        $this->nrcependereco = $nrcependereco;
    }

    /**
     * @param $nmbairroendereco
     * @return MigEnderecoparc
     */
    public function setNmbairroendereco ($nmbairroendereco) {
        $nmbairroendereco = substr($nmbairroendereco, 0, 100);
        $this->nmbairroendereco = $nmbairroendereco;
    }

    /**
     * @param $dscompleendereco
     * @return MigEnderecoparc
     */
    public function setDscompleendereco ($dscompleendereco) {
        $dscompleendereco = substr($dscompleendereco, 0, 50);
        $this->dscompleendereco = $dscompleendereco;
    }

    /**
     * @param $cdlogradouro
     * @return MigEnderecoparc
     */
    public function setCdlogradouro ($cdlogradouro) {
        $cdlogradouro = substr($cdlogradouro, 0, 4);
        $this->cdlogradouro = $cdlogradouro;
    }

}