/* Sistemas Integrados TEKNISA

Nome: DTULTATU_PARAMBLOQNFAFIL

@C:\Web_506\Sql\End_Conv\SQLServer\03AC_GERTRGS_DTULTATU_PARAMBLOQNFAFOR.sql

Descrio:
Rotina para atualizao de cache da tabela PARAMBLOQNFAFOR

Criao:
29/09/2009 - Fabricio Marcelo
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PARAMBLOQNFAFOR'  and
            type = 'TR'                          and
            u.uid = o.uid                        and
            u.name = USER)
   DROP TRIGGER DTULTATU_PARAMBLOQNFAFOR
GO

CREATE TRIGGER DTULTATU_PARAMBLOQNFAFOR
ON PARAMBLOQNFAFOR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			(SELECT 'PARAMBLOQNFAFOR', NULL, 'CDFORNECED=' + CDFORNECED +
                                          ';IDENTRSAIDOP=' + IDENTRSAIDOP +
                                          ';CDTIPOOPER=' + CDTIPOOPER +
                                          ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PARAMBLOQNFAFOR
      SET DTULTATU = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PARAMBLOQNFAFOR.CDFORNECED, 0)   = ISNULL(INSERTED.CDFORNECED, 0))   AND
            (ISNULL(PARAMBLOQNFAFOR.IDENTRSAIDOP, 0) = ISNULL(INSERTED.IDENTRSAIDOP, 0)) AND
            (ISNULL(PARAMBLOQNFAFOR.CDTIPOOPER, 0)   = ISNULL(INSERTED.CDTIPOOPER, 0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PARAMBLOQNFAFOR','5.06.032';
GO
